<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Task41.75</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>
<body>
  <div class="container">
    <h2 style="text-align: center;">Danh sách đơn hàng</h2>
    <div class = "container jumbotron">
      <div class="row">
        <label class = "col-sm-2 col-form-label">Trạng thái order</label>
        <div class = "col-sm-3">
          <select id="select-order-status" class = "form-control">
            <option value="all">(All)</option>
            <option value="open">Open</option>
            <option value="confirmed">Confirmed</option>
            <option value="cancel">Cancel</option>
          </select>
        </div>
        <label class = "col-sm-2 col-form-label">Loại pizza</label>
        <div class = "col-sm-3">
          <select id="select-pizza" class = "form-control">
            <option value="all">(All)</option>
            <option value="Hawaii">Hawaii</option>
            <option value="Bacon">Bacon</option>
            <option value="Seafood">Seafood</option>
          </select>
        </div>
        <button class="btn btn-info col-sm-2" id="btn-filter-orders">Lọc</button>
      </div>
    </div>
      <table class="table table-bordered table-striped table-hover" id="order-table">
          <thead>
            <tr>
              <th>Order Code</th>
              <th>Kích cỡ combo</th>
              <th>Loại pizza</th>
              <th>Nước uống</th>
              <th>Thành tiền</th>
              <th>Họ và tên</th>
              <th>Số điện thoại</th>
              <th>Trạng thái</th>
              <th>Chi tiết</th>
            </tr>
      </table>
    </div>
    <!-- Order detail modal -->
    <div>
      <div id="order-modal" class="modal fade" tabindex="-1">
        <div class="modal-dialog">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title" id="h5-modal-title">Order Detail!!!</h5>
              <button class="close" data-dismiss="modal">&times;</button>
            </div>
            <div class="modal-body">
              <form>
                <div class="row form-group">
                  <div class="col-sm-4">
                    <label for="input-order-code">Order Code</label>
                  </div>
                  <div class="col-sm-8">
                    <input type="text" id="input-order-code" name="ordercode" placeholder="Order code"
                      class="form-control">
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-4">
                    <label for="select-combo">Pizza Size</label>
                  </div>
                  <div class="col-sm-8">
                    <select type="select" id="select-combo" name="combo" class="form-control">
                      <option value="S">S</option>
                      <option value="M">M</option>
                      <option value="L">L</option>
                    </select>
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-4">
                    <label for="input-duong-kinh">Đường kính</label>
                  </div>
                  <div class="col-sm-8">
                    <input type="text" id="input-duong-kinh" name="duongkinh" placeholder="Đường kính"
                      class="form-control">
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-4">
                    <label for="input-suon">Sườn</label>
                  </div>
                  <div class="col-sm-8">
                    <input type="text" id="input-suon" name="suon" placeholder="Sườn (miếng)"
                      class="form-control">
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-4">
                    <label for="input-salad">Salad</label>
                  </div>
                  <div class="col-sm-8">
                    <input type="text" id="input-salad" name="salad" placeholder="Salad (gr)"
                      class="form-control">
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-4">
                    <label for="select-pizza">Pizza Type</label>
                  </div>
                  <div class="col-sm-8">
                    <select type="select" id="select-pizza" name="pizza" class="form-control">
                      <option value="Hawaii">Hawaii</option>
                      <option value="Bacon">Bacon</option>
                      <option value="Seafood">Seafood</option>
                    </select>
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-4">
                    <label for="input-id-voucher">Id Voucher</label>
                  </div>
                  <div class="col-sm-8">
                    <input type="text" id="input-id-voucher" name="idvoucher" placeholder="Id Voucher"
                      class="form-control">
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-4">
                    <label for="input-thanh-tien">Thành tiền</label>
                  </div>
                  <div class="col-sm-8">
                    <input type="text" id="input-thanh-tien" name="price" placeholder="Thành tiền"
                      class="form-control">
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-4">
                    <label for="input-giam-gia">Giảm giá</label>
                  </div>
                  <div class="col-sm-8">
                    <input type="text" id="input-giam-gia" name="discount" placeholder="Giảm giá"
                      class="form-control">
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-4">
                    <label for="select-drink">Loại đồ uống</label>
                  </div>
                  <div class="col-sm-8">
                    <select type="select" id="select-drink" name="drink" class="form-control"></select>
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-4">
                    <label for="input-so-luong-nuoc-uong">Số lượng nước uống</label>
                  </div>
                  <div class="col-sm-8">
                    <input type="text" id="input-so-luong-nuoc-uong" name="soluongnuoc" placeholder="Số lượng nước uống"
                      class="form-control">
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-4">
                    <label for="input-name">Họ và tên</label>
                  </div>
                  <div class="col-sm-8">
                    <input type="text" id="input-name" name="name" placeholder="Họ và tên"
                      class="form-control">
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-4">
                    <label for="input-email">Email</label>
                  </div>
                  <div class="col-sm-8">
                    <input type="text" id="input-email" name="email" placeholder="Email"
                      class="form-control">
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-4">
                    <label for="input-phone">Số điện thoại</label>
                  </div>
                  <div class="col-sm-8">
                    <input type="text" id="input-phone" name="phone" placeholder="Số điện thoại"
                      class="form-control">
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-4">
                    <label for="input-dia-chi">Địa chỉ</label>
                  </div>
                  <div class="col-sm-8">
                    <input type="text" id="input-dia-chi" name="address" placeholder="Địa chỉ"
                      class="form-control">
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-4">
                    <label for="input-message">Lời nhắn</label>
                  </div>
                  <div class="col-sm-8">
                    <input type="text" id="input-message" name="message" placeholder="Lời nhắn"
                      class="form-control">
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-4">
                    <label for="input-order-date">Ngày order</label>
                  </div>
                  <div class="col-sm-8">
                    <input type="text" id="input-order-date" name="orderdate" placeholder="Ngày order"
                      class="form-control">
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-4">
                    <label for="input-edit-date">Ngày chỉnh sửa</label>
                  </div>
                  <div class="col-sm-8">
                    <input type="text" id="input-edit-date" name="editdate" placeholder="Ngày chỉnh sửa"
                      class="form-control">
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-6">
                    <button class="col-sm-12 btn btn-warning" id="btn-confirm" >Confirm</button>
                  </div>
                  <div class="col-sm-6">
                    <button class="col-sm-12 btn btn-danger" id="btn-cancel">Cancel</button>
                  </div>
                </div>
              </form>
            </div>
            <div class="modal-footer">
                <button class="btn btn-secondary" id="btn-close" data-dismiss="modal">Close</button>
            </div>
          </div>
        </div>
      </div>
    </div>
</body>
<script>
    "use strict";
  $(document).ready(function() {
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_CREATE_OK = 201; // status 201 tao thanh cong
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    // base url API
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";

    var gOrdersArr =[];
    const gCOLUMN_CODE = 0;
    const gCOLUMN_COMBO = 1;
    const gCOLUMN_PIZZA = 2;
    const gCOLUMN_DRINK = 3;
    const gCOLUMN_AMOUNT = 4 ;
    const gCOLUMN_NAME = 5;
    const gCOLUMN_PHONE = 6;
    const gCOLUMN_ORDER_STATUS = 7;
    const gCOLUMN_DETAIL = 8;

    const gUSER_COL = ["orderCode","kichCo","loaiPizza","idLoaiNuocUong","thanhTien","hoTen","soDienThoai","trangThai","detail"]
    
    //biến lưu order id và ordercode của order được xem chi tiết
    var gOrderId;
    var gOrderCode;
    var gOrderObj;

    // khởi tạo data table  - chưa có data
    var gOrderTable = $("#order-table").DataTable( {
      // Khai báo các cột của datatable
      "columns" : [
          { "data" : gUSER_COL[gCOLUMN_CODE] },
          { "data" : gUSER_COL[gCOLUMN_COMBO] },
          { "data" : gUSER_COL[gCOLUMN_PIZZA] },
          { "data" : gUSER_COL[gCOLUMN_DRINK] },
          { "data" : gUSER_COL[gCOLUMN_AMOUNT] },
          { "data" : gUSER_COL[gCOLUMN_NAME] },
          { "data" : gUSER_COL[gCOLUMN_PHONE] },
          { "data" : gUSER_COL[gCOLUMN_ORDER_STATUS] },
          { "data" : gUSER_COL[gCOLUMN_DETAIL] }
      ],
      // Ghi đè nội dung của cột action, chuyển thành button chi tiết
      "columnDefs": [ 
      {
          "targets": gCOLUMN_DETAIL,
          "defaultContent": "<button class='info-order btn btn-info'>Chi tiết</button>"
      }]
    });
    
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    onPageLoading();
    //load danh sách drinklist
    getDrinkListAjaxClick();

    //gán sự kiện cho nút filter
    $("#btn-filter-orders").click(function(){
      onBtnFilterOrderClick();
    })
    // gán click event handler cho button chi tiet
    $("#order-table").on("click", ".info-order", function() {
      onButtonChiTietClick(this); // this là button được ấn
    });

    // gán click event handler cho button confirm
    $("#btn-confirm").on("click", function() {
      onButtonConfirmClick(this); // this là button được ấn
    });
    // gán click event handler cho button delete
    $("#btn-cancel").on("click", function() {
      onButtonCancelClick(this); // this là button được ấn
    });

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */  
    // hàm chạy khi trang được load
    function onPageLoading() {
      // lấy data từ server
      $.ajax({
        url: gBASE_URL,
        type: "GET",
        dataType: 'json',
        success: function(responseObject){
          //debugger;
          gOrdersArr = responseObject;
          loadDataToTable(responseObject);
        },
        error: function(error){
          console.assert(error.responseText);
        }
      });
    }
    //hàm xử lý nút sự kiện filter click
    function onBtnFilterOrderClick(){
      var vFilterObj = {
        trangThai:"",
        loaiPizza: ""
      };
      //b1: thu thập dữ liệu
      thuThapDuLieuFilter(vFilterObj);
      //b2: validate(không có)
      //b3: filter order
      var vOrdersResult = filterOrders(vFilterObj);

      //b4: hiển thị dữ liệu sau khi lọc
      loadDataToTable(vOrdersResult);
    }
    //hàm gọi API order theo ordercode
    function getAjaxDetailOrder(paramOrderCode){
      "use strict";
        $.ajax({
            url: gBASE_URL + "/" + paramOrderCode,
            type: "GET",
            dataType: 'json',
            success: function(responseObject){
            //debugger;
            handleOrderDetail(responseObject);
            gOrderObj = responseObject;
            },
            error: function(error){
            console.assert(error.responseText);
            }
        });
             
    }
    // infoFunction sẽ là function các nút cùng gọi
    function onButtonChiTietClick(paramChiTietButton) {
      //Xác định thẻ tr là cha của nút được chọn
      var vRowSelected = $(paramChiTietButton).parents('tr');
      //Lấy datatable row
      var vDatatableRow = gOrderTable.row(vRowSelected); 
      //Lấy data của dòng 
      var vOrderData = vDatatableRow.data();
      gOrderId = vOrderData.id;
      gOrderCode = vOrderData.orderCode;
      console.log("Order id: " + gOrderId);
      console.log("Order code: " + gOrderCode);
      getAjaxDetailOrder(gOrderCode);
      $("#order-modal").modal("show");
    }
    //hàm xử lý sự kiện nhấn nút xác nhận order
    function onButtonConfirmClick(){
      "use strict";
      //b1: đọc
      console.log("id của đơn hàng là: " + gOrderId);
      var vObjectRequest = {
        trangThai: "confirmed" //3 trạng thái: open, confirmed, cancel
      };
      var vJsonString = JSON.stringify(vObjectRequest);
      //b2: validate (không cần)
      //b3: xử lý data
      getAjaxUpdateOrderStatus(gOrderId, vJsonString);
      //b4: hiển thị
      console.log("Order đã được xác nhận!");
      $("#order-modal").modal("hide");
    }
    //hàm xử lý sự kiện nhấn nút cancel order
    function onButtonCancelClick(){
      "use strict";
      //b1: đọc
      console.log("id của đơn hàng là: " + gOrderId);
      var vObjectRequest = {
        trangThai: "cancel" //3 trạng thái: open, confirmed, cancel
      };
      var vJsonString = JSON.stringify(vObjectRequest);
      //b2: validate (không cần)
      //b3: xử lý data
      getAjaxUpdateOrderStatus(gOrderId, vJsonString);
      //b4: hiển thị
      console.log("Order đã được hủy!");
      $("#order-modal").modal("hide");
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình */
    // load data to table
    function loadDataToTable(paramResponseObject) {
      //Xóa toàn bộ dữ liệu đang có của bảng
      gOrderTable.clear();
      //Cập nhật data cho bảng 
      gOrderTable.rows.add(paramResponseObject);
      //Cập nhật lại giao diện hiển thị bảng
      gOrderTable.draw();
    }
    //đọc thông tin dùng để lọc
    function thuThapDuLieuFilter(paramFilterObj){
      paramFilterObj.trangThai = $("#select-order-status").val();
      paramFilterObj.loaiPizza = $("#select-pizza").val();
    }
    //hàm lọc theo Filter Object
    function filterOrders(paramFilterObj){
      var vOrders = [];
      vOrders = gOrdersArr.filter(function(paramOrder){
        return ((paramOrder.trangThai == paramFilterObj.trangThai || paramFilterObj.trangThai == "all") 
        && (paramOrder.loaiPizza == paramFilterObj.loaiPizza|| paramFilterObj.loaiPizza == "all"));
      });
      return vOrders;
    }
    //hàm gọi api select drink
    function getDrinkListAjaxClick(){
      "use strict";
      $.ajax({
        url: "http://203.171.20.210:8080/devcamp-pizza365/drinks",
        dataType: "json",
        type: "GET",
        success: function(res){
          console.log(res);
          handleDrinkList(res);
        },
        error: function(ajaxContext){
          alert(ajaxContext.responseText);
        }
      });
    }
    //hàm load option cho drink select element
    function handleDrinkList(paramDrink){
      "use strict";
      var vArrayDrinkList = paramDrink;
      //load data to drink select
      var vSelectDrink = document.getElementById("select-drink");
      for (var bI = 0; bI < vArrayDrinkList.length; bI++){
        var vDrinkOption = document.createElement("option");
        vDrinkOption.value = vArrayDrinkList[bI].maNuocUong;
        vDrinkOption.text =  vArrayDrinkList[bI].tenNuocUong;
        vSelectDrink.appendChild(vDrinkOption);
      }
    }
    //hàm xử lý xác nhận order detail
    function handleOrderDetail(paramOrderObj){
      "use strict";
      $("#input-order-code").val(paramOrderObj.orderCode);
      $("#select-combo").val(paramOrderObj.kichCo);
      $("#input-duong-kinh").val(paramOrderObj.duongKinh);
      $("#input-suon").val(paramOrderObj.suon);
      $("#input-salad").val(paramOrderObj.salad);
      $("#select-pizza").val(paramOrderObj.loaiPizza);
      $("#input-id-voucher").val(paramOrderObj.idVourcher);
      $("#input-thanh-tien").val(paramOrderObj.thanhTien);
      $("#input-giam-gia").val(paramOrderObj.giamGia);
      $("#select-drink").val(paramOrderObj.idLoaiNuocUong);
      $("#input-so-luong-nuoc-uong").val(paramOrderObj.soLuongNuoc);

      $("#input-name").val(paramOrderObj.hoTen);
      $("#input-email").val(paramOrderObj.email);
      $("#input-phone").val(paramOrderObj.soDienThoai);
      $("#input-dia-chi").val(paramOrderObj.diaChi);
      $("#input-message").val(paramOrderObj.loiNhan);

      $("#input-order-date").val(paramOrderObj.ngayTao);
      $("#input-edit-date").val(paramOrderObj.ngayCapNhat);

    }
    //Api cập nhật trạng thái order
    function getAjaxUpdateOrderStatus(paramOrderId, paramJsonString){
      $.ajax({
        url: gBASE_URL + "/" + paramOrderId,
        data: paramJsonString,
        type: "PUT",
        contentType: "application/json", // added content type
        success: function(paramResponse){
          alert("Order Id: " + paramResponse.id + "status is updated succesfully!");
          console.log("%cUPDATED INFORMATION: ", "color:orange");
          console.log(paramResponse);
        },
        error: function(error){
            console.assert(error.responseText);
        }
      });
    }
  });

</script>
</html>